/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the UserMessengerCreateable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserMessengerCreateable{}

// UserMessengerCreateable struct for UserMessengerCreateable
type UserMessengerCreateable struct {
	MessengerId string `json:"messenger_id"`
	MessengerType string `json:"messenger_type"`
	Purpose string `json:"purpose"`
	Password *string `json:"password,omitempty"`
}

// NewUserMessengerCreateable instantiates a new UserMessengerCreateable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserMessengerCreateable(messengerId string, messengerType string, purpose string) *UserMessengerCreateable {
	this := UserMessengerCreateable{}
	this.MessengerId = messengerId
	this.MessengerType = messengerType
	this.Purpose = purpose
	return &this
}

// NewUserMessengerCreateableWithDefaults instantiates a new UserMessengerCreateable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserMessengerCreateableWithDefaults() *UserMessengerCreateable {
	this := UserMessengerCreateable{}
	return &this
}

// GetMessengerId returns the MessengerId field value
func (o *UserMessengerCreateable) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *UserMessengerCreateable) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *UserMessengerCreateable) SetMessengerId(v string) {
	o.MessengerId = v
}

// GetMessengerType returns the MessengerType field value
func (o *UserMessengerCreateable) GetMessengerType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerType
}

// GetMessengerTypeOk returns a tuple with the MessengerType field value
// and a boolean to check if the value has been set.
func (o *UserMessengerCreateable) GetMessengerTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerType, true
}

// SetMessengerType sets field value
func (o *UserMessengerCreateable) SetMessengerType(v string) {
	o.MessengerType = v
}

// GetPurpose returns the Purpose field value
func (o *UserMessengerCreateable) GetPurpose() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Purpose
}

// GetPurposeOk returns a tuple with the Purpose field value
// and a boolean to check if the value has been set.
func (o *UserMessengerCreateable) GetPurposeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Purpose, true
}

// SetPurpose sets field value
func (o *UserMessengerCreateable) SetPurpose(v string) {
	o.Purpose = v
}

// GetPassword returns the Password field value if set, zero value otherwise.
func (o *UserMessengerCreateable) GetPassword() string {
	if o == nil || IsNil(o.Password) {
		var ret string
		return ret
	}
	return *o.Password
}

// GetPasswordOk returns a tuple with the Password field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserMessengerCreateable) GetPasswordOk() (*string, bool) {
	if o == nil || IsNil(o.Password) {
		return nil, false
	}
	return o.Password, true
}

// HasPassword returns a boolean if a field has been set.
func (o *UserMessengerCreateable) HasPassword() bool {
	if o != nil && !IsNil(o.Password) {
		return true
	}

	return false
}

// SetPassword gets a reference to the given string and assigns it to the Password field.
func (o *UserMessengerCreateable) SetPassword(v string) {
	o.Password = &v
}

func (o UserMessengerCreateable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserMessengerCreateable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["messenger_id"] = o.MessengerId
	toSerialize["messenger_type"] = o.MessengerType
	toSerialize["purpose"] = o.Purpose
	if !IsNil(o.Password) {
		toSerialize["password"] = o.Password
	}
	return toSerialize, nil
}

type NullableUserMessengerCreateable struct {
	value *UserMessengerCreateable
	isSet bool
}

func (v NullableUserMessengerCreateable) Get() *UserMessengerCreateable {
	return v.value
}

func (v *NullableUserMessengerCreateable) Set(val *UserMessengerCreateable) {
	v.value = val
	v.isSet = true
}

func (v NullableUserMessengerCreateable) IsSet() bool {
	return v.isSet
}

func (v *NullableUserMessengerCreateable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserMessengerCreateable(val *UserMessengerCreateable) *NullableUserMessengerCreateable {
	return &NullableUserMessengerCreateable{value: val, isSet: true}
}

func (v NullableUserMessengerCreateable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserMessengerCreateable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


